﻿Imports System
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Ink
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.ComponentModel
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System.Linq

Namespace DragDropSample.ViewModels
    Public Class MyViewModel
        Implements INotifyPropertyChanged
        Public Shared Function GetItems(ByVal name As String) As IList(Of MyViewModel)
            Dim result = New ObservableCollection(Of MyViewModel)()
            For Each num In Enumerable.Range(1, 15)
                Dim item = New MyViewModel()
                item.DateCreated = DateTime.Today.AddDays(-num Mod 5)
                item.Price = num * 100 + Convert.ToDouble(num) / 100
                item.Title = [String].Format("{0} {1}", name, num)

                result.Add(item)
            Next
            Return result
        End Function

        Private m_price As Double
        Public Property Price() As Double
            Get
                Return Me.m_price
            End Get
            Set(ByVal value As Double)
                If Me.m_price <> value Then
                    Me.m_price = value
                    OnPropertyChanged("Price")
                End If
            End Set
        End Property

        Private m_dateCreated As DateTime
        Public Property DateCreated() As DateTime
            Get
                Return Me.m_dateCreated
            End Get
            Set(ByVal value As DateTime)
                If Me.m_dateCreated <> value Then
                    Me.m_dateCreated = value
                    OnPropertyChanged("DateCreated")
                End If
            End Set
        End Property

        Private m_title As [String]
        Public Property Title() As [String]
            Get
                Return Me.m_title
            End Get
            Set(ByVal value As [String])
                If Me.m_title <> value Then
                    Me.m_title = value
                    OnPropertyChanged("Title")
                End If
            End Set
        End Property

        ''' <summary>
        ''' Called when the value of a property changes.
        ''' </summary>
        ''' <param name="propertyName">The name of the property that has changed.</param>
        Protected Overridable Sub OnPropertyChanged(ByVal propertyName As [String])
            If [String].IsNullOrEmpty(propertyName) Then
                Exit Sub
            End If
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
        End Sub

        ''' <summary>
        ''' Raised when the value of one of the properties changes.
        ''' </summary>
        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    End Class
End Namespace